package cn.iocoder.yudao.module.visit.service.customerinfo;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.visit.controller.admin.customerinfo.vo.*;
import cn.iocoder.yudao.module.visit.dal.dataobject.customerinfo.CustomerInfoDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 客户信息 Service 接口
 *
 * @author 超级管理员
 */
public interface CustomerInfoService {

    /**
     * 创建客户信息
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createCustomerInfo(@Valid CustomerInfoSaveReqVO createReqVO);

    /**
     * 更新客户信息
     *
     * @param updateReqVO 更新信息
     */
    void updateCustomerInfo(@Valid CustomerInfoSaveReqVO updateReqVO);

    /**
     * 删除客户信息
     *
     * @param id 编号
     */
    void deleteCustomerInfo(Long id);

    /**
     * 获得客户信息
     *
     * @param id 编号
     * @return 客户信息
     */
    CustomerInfoDO getCustomerInfo(Long id);

    /**
     * 获得客户信息分页
     *
     * @param pageReqVO 分页查询
     * @return 客户信息分页
     */
    PageResult<CustomerInfoDO> getCustomerInfoPage(CustomerInfoPageReqVO pageReqVO);

    List<CustomerInfoDO> getCustomerInfoByCompanyName(String companyName);
    List<CustomerInfoDO> getCustomerInfoByContact(String contact);


    List<CustomerInfoDO> getAllCustomerInfo();

    CustomerImportRespVO importCustomerList(List<CustomerImportExcelVO> list, Boolean updateSupport);
}